#!/usr/bin/perl -w 
use strict;
## Dieses Script soll die Verwendung von @ARGV demonstrieren.
## Anzahl der Sequenzen in einem fastq file zaehlen
## ich brauche dafuer> 1) sequenzfile namen, 2) optional einen outputfile,
## Vorwissen: a) info fuer seq read ueber mehr als eine zeile ausgedehnt.
## b) in welcher Zeile steht relevante info
## jede vierte Zeile ist interessant, oder info fuer einen read erstreckt sich
## ueber vier Zeilen

## Loesungsweg a> zaehle seq-identifier

my $infile = ''; # soll info ueber filename aufnehmen
my $outfile = '';

########### user defines input and output file
#$infile = $ARGV[0];
#$outfile = $ARGV[0];
# alternativ
#($infile) = @ARGV;
#($outfile) = @ARGV;
# alternativ
$infile = shift(@ARGV);
$outfile = shift(@ARGV);
chomp($outfile);
print "infile is $infile\n";
print "outfile is $outfile\n";

############## open filehandle for infile and outfile
if (-e "$infile") {
	my $count = 3;
	my $seqcount = 0;
	my $idcount = 0;
	my @ids = ();
	open (IN, "$infile") or die "file $infile cannot be opened for reading\n";
	while (my $line = <IN> and $count <49998) {
		$count ++;
		$seqcount ++;
		if ($count%4==0 and $count >0) {
#			print "$line";
			my $first = substr($line, 0, 1);
			if ($first ne '@') {
				 print "da ist was falsch mit $infile! In Zeile $count steht keine valide seqid: $line\n";
			}
			#if ($line =~ /^@/)
			else {
				$idcount++;
				push(@ids, $line);
			}
		}
	}
	my $idcount2 = scalar(@ids);
	print "$infile has $seqcount lines\n";
	print "$infile has $idcount seqids\n";
	print "$infile has $idcount2 seqids counted via array\n";


######################### arbeiten mit liste als input
	my @seqs = <IN>;
	print join "\n", @seqs;
#	print ($seqs[0] . "\n");
	close (IN);
}
else {
	print "$infile does not exist in the specified path\n";
	my $path = `pwd`;
	print "path is $path\n";
	exit;
}
exit; 
